from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Directory, Boolean, Int, String

Msstitch_Psmtable_V0_1_0 = CommandToolBuilder(tool="msstitch_psmtable", base_command=["msstitch", "psmtable"], inputs=[ToolInput(tag="in_input_file_format", input_type=File(optional=True), prefix="-i", doc=InputDocumentation(doc="Input file of {} format")), ToolInput(tag="in_directory_to_output", input_type=Directory(optional=True), prefix="-d", doc=InputDocumentation(doc="Directory to output in")), ToolInput(tag="in_output_file", input_type=File(optional=True), prefix="-o", doc=InputDocumentation(doc="Output file")), ToolInput(tag="in_dbfile", input_type=File(optional=True), prefix="--dbfile", doc=InputDocumentation(doc="Database lookup file")), ToolInput(tag="in_ms_one_quant", input_type=Boolean(optional=True), prefix="--ms1quant", doc=InputDocumentation(doc="Specifies to add precursor quant data from lookup DB\nto output table")), ToolInput(tag="in_isobaric", input_type=Boolean(optional=True), prefix="--isobaric", doc=InputDocumentation(doc="Specifies to add isobaric quant data from lookup DB to\noutput table")), ToolInput(tag="in_unroll", input_type=Boolean(optional=True), prefix="--unroll", doc=InputDocumentation(doc="PSM table from Mzid2TSV contains either one PSM per\nline with all the proteins of that shared peptide on\nthe same line (not unrolled, default), or one\nPSM/protein match per line where each protein from\nthat shared peptide gets its own line (unrolled).")), ToolInput(tag="in_spectra_col", input_type=Int(optional=True), prefix="--spectracol", doc=InputDocumentation(doc="Column number in which spectra file names are, in case\nsome framework has changed the file names. First\ncolumn number is 1.")), ToolInput(tag="in_add_bio_set", input_type=Boolean(optional=True), prefix="--addbioset", doc=InputDocumentation(doc="Add biological setname from DB lookup to PSM table")), ToolInput(tag="in_add_misc_leav", input_type=Boolean(optional=True), prefix="--addmiscleav", doc=InputDocumentation(doc="Add missed cleavages to PSM table")), ToolInput(tag="in_genes", input_type=Boolean(optional=True), prefix="--genes", doc=InputDocumentation(doc="Specifies to add genes to PSM table")), ToolInput(tag="in_protein_group", input_type=Boolean(optional=True), prefix="--proteingroup", doc=InputDocumentation(doc="Specifies to add protein groups to PSM table")), ToolInput(tag="in_fast_a", input_type=String(optional=True), prefix="--fasta", doc=InputDocumentation(doc="FASTA sequence database")), ToolInput(tag="in_gene_field", input_type=Int(optional=True), prefix="--genefield", doc=InputDocumentation(doc="Field nr (first=1) in FASTA that contains gene name\nwhen using --fastadelim to parse the gene names")), ToolInput(tag="in_fast_a_delim", input_type=String(optional=True), prefix="--fastadelim", doc=InputDocumentation(doc="Delimiter in FASTA header, used to parse gene names in\ncase of non-ENSEMBL/Uniprot\n"))], outputs=[ToolOutput(tag="out_directory_to_output", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_directory_to_output", type_hint=File()), doc=OutputDocumentation(doc="Directory to output in")), ToolOutput(tag="out_output_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file", type_hint=File()), doc=OutputDocumentation(doc="Output file"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Msstitch_Psmtable_V0_1_0().translate("wdl", allow_empty_container=True)

